<script lang="ts">
    import { onMount } from 'svelte'
    import { fade } from 'svelte/transition'
    import { cubicIn, cubicOut } from 'svelte/easing'
    import { goto } from '$app/navigation'
    import Nav from '$components/Nav/InGame/Nav.svelte'
    import NavIcon from '$components/Nav/Public/NavIcon.svelte'
    import user from '$lib/user'
    import ErrorStack from '$lib/errors/Stack.svelte'
    import LoadingMatrix from '../Icons/LoadingMatrix.svelte'

    export let loaded = true

    // Redirect to login unlogged users
    onMount(() => {
        user.subscribe(async u => {
            if (u === undefined) await goto('/login')
        })
    })
</script>

{#if loaded}
    <section transition:fade={{ duration: 350, delay: 250, easing: cubicOut }}>
        <header>
            <slot name="header-left">
                <div class="icon">
                    <NavIcon />
                </div>
            </slot>

            <Nav expanded={!$$slots['header-left']} />
        </header>

        <slot />
    </section>
{:else}
    <section id="loading" transition:fade={{ duration: 300, easing: cubicIn }}>
        <LoadingMatrix />
        <h1>Gathering of lost starships</h1>
    </section>
{/if}

<ErrorStack />

<style lang="postcss">
    :global(#sapper) {
        @apply bg-white dark:bg-trueGray-800;
    }

    section {
        @apply min-h-screen h-full flex
        bg-white dark:bg-trueGray-800;
    }

    #loading {
        @apply flex items-center justify-center gap-x-6
        text-trueGray-900 dark:text-trueGray-100
        bg-gradient-to-b from-fuchsia-200 to-indigo-200
        dark:from-fuchsia-900 dark:to-indigo-900;

        h1 {
            @apply font-poppins text-2xl font-semibold;
        }
    }

    header {
        @apply fixed top-0 inset-x-0 z-40 grid grid-cols-7 h-16;

        & > :global(*) {
            @apply h-full;
        }

        .icon {
            @apply relative col-span-1 -mr-2 py-3 flex justify-center text-trueGray-800 dark:text-trueGray-50;
            clip-path: polygon(100% 0, calc(100% - 2rem) 100%, 0 calc(100% - 0.75rem), 0 0);

            &::before {
                content: '';
                @apply absolute inset-0 z-[-1]
                bg-gradient-to-r from-fuchsia-200/80  to-indigo-200/80
                dark:from-fuchsia-900/80 dark:to-indigo-900/80
                backdrop-blur-sm;
            }
        }
    }
</style>
